<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSalaryPreCalculationItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfSalaryPreCalculationItem_V2 extends AbstractStructArrayBase
{
    /**
     * The SalaryPreCalculationItem_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SalaryPreCalculationItem_V2[]
     */
    public $SalaryPreCalculationItem_V2;
    /**
     * Constructor method for ArrayOfSalaryPreCalculationItem_V2
     * @uses ArrayOfSalaryPreCalculationItem_V2::setSalaryPreCalculationItem_V2()
     * @param \StructType\SalaryPreCalculationItem_V2[] $salaryPreCalculationItem_V2
     */
    public function __construct(array $salaryPreCalculationItem_V2 = array())
    {
        $this
            ->setSalaryPreCalculationItem_V2($salaryPreCalculationItem_V2);
    }
    /**
     * Get SalaryPreCalculationItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SalaryPreCalculationItem_V2[]|null
     */
    public function getSalaryPreCalculationItem_V2()
    {
        return isset($this->SalaryPreCalculationItem_V2) ? $this->SalaryPreCalculationItem_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSalaryPreCalculationItem_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSalaryPreCalculationItem_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSalaryPreCalculationItem_V2ForArrayConstraintsFromSetSalaryPreCalculationItem_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item instanceof \StructType\SalaryPreCalculationItem_V2) {
                $invalidValues[] = is_object($arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item) ? get_class($arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item) : sprintf('%s(%s)', gettype($arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item), var_export($arrayOfSalaryPreCalculationItem_V2SalaryPreCalculationItem_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SalaryPreCalculationItem_V2 property can only contain items of type \StructType\SalaryPreCalculationItem_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SalaryPreCalculationItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SalaryPreCalculationItem_V2[] $salaryPreCalculationItem_V2
     * @return \ArrayType\ArrayOfSalaryPreCalculationItem_V2
     */
    public function setSalaryPreCalculationItem_V2(array $salaryPreCalculationItem_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($salaryPreCalculationItem_V2ArrayErrorMessage = self::validateSalaryPreCalculationItem_V2ForArrayConstraintsFromSetSalaryPreCalculationItem_V2($salaryPreCalculationItem_V2))) {
            throw new \InvalidArgumentException($salaryPreCalculationItem_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($salaryPreCalculationItem_V2) || (is_array($salaryPreCalculationItem_V2) && empty($salaryPreCalculationItem_V2))) {
            unset($this->SalaryPreCalculationItem_V2);
        } else {
            $this->SalaryPreCalculationItem_V2 = $salaryPreCalculationItem_V2;
        }
        return $this;
    }
    /**
     * Add item to SalaryPreCalculationItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\SalaryPreCalculationItem_V2 $item
     * @return \ArrayType\ArrayOfSalaryPreCalculationItem_V2
     */
    public function addToSalaryPreCalculationItem_V2(\StructType\SalaryPreCalculationItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SalaryPreCalculationItem_V2) {
            throw new \InvalidArgumentException(sprintf('The SalaryPreCalculationItem_V2 property can only contain items of type \StructType\SalaryPreCalculationItem_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SalaryPreCalculationItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SalaryPreCalculationItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SalaryPreCalculationItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SalaryPreCalculationItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SalaryPreCalculationItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SalaryPreCalculationItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SalaryPreCalculationItem_V2
     */
    public function getAttributeName()
    {
        return 'SalaryPreCalculationItem_V2';
    }
}
